package com.ekexiu.console.system.po;

import com.ekexiu.console.basepo.CreateTimeSupported;
import com.ekexiu.console.basepo.ModifyTimeSupported;
import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.core.defaultImpl.FixLenStringHandler;
import org.jfw.apt.orm.core.defaultImpl.IntHandler;
import org.jfw.apt.orm.core.defaultImpl.LongHandler;
import org.jfw.apt.orm.core.enums.DE;

/**
 * Created by TT on 2017/7/26.
 */
@Table
@PrimaryKey("articleId")
public class Article implements CreateTimeSupported, ModifyTimeSupported {
    private String articleId;
    private String professorId;
    private String articleTitle;
    private String articleContent;
    private String subject;
    private String industry;
    private String createTime;
    private String modifyTime;
    private String publishTime;
    private String articleImg;
    private String orgId;
    private String articleType;
    private int articleAgree;
    private int pageViews;
    private String status;
    private long shareId;
    private long sortNum;

    @Column(DE.id_32)
    public String getArticleId() {
        return articleId;
    }
    public void setArticleId(String articleId) {
        this.articleId = articleId;
    }
    @Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(32)",nullable=true,renewable=false)
    public String getProfessorId() {
        return professorId;
    }
    public void setProfessorId(String professorId) {
        this.professorId = professorId;
    }
    @Column(value= DE.string_de,dbType="TEXT")
    public String getArticleTitle() {
        return articleTitle;
    }
    public void setArticleTitle(String articleTitle) {
        this.articleTitle = articleTitle;
    }
    @Column(value=DE.String_de,dbType="TEXT")
    public String getArticleContent() {
        return articleContent;
    }
    public void setArticleContent(String articleContent) {
        this.articleContent = articleContent;
    }
    @Column(value=DE.String_de,dbType="TEXT")
    public String getSubject() {
        return subject;
    }
    public void setSubject(String subject) {
        this.subject = subject;
    }
    @Column(value=DE.String_de,dbType="TEXT")
    public String getIndustry() {
        return industry;
    }
    public void setIndustry(String industry) {
        this.industry = industry;
    }
    public String getCreateTime() {
        return createTime;
    }
    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }
    public String getModifyTime() {
        return modifyTime;
    }
    public void setModifyTime(String modifyTime) {
        this.modifyTime = modifyTime;
    }
    @Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(14)",nullable=true,renewable=false)
    public String getPublishTime() {
        return publishTime;
    }
    public void setPublishTime(String publishTime) {
        this.publishTime = publishTime;
    }
    @Column(DE.String_de)
    public String getArticleImg() {
        return articleImg;
    }
    public void setArticleImg(String articleImg) {
        this.articleImg = articleImg;
    }
    @Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(32)",nullable=true,renewable=false)
    public String getOrgId() {
        return orgId;
    }
    public void setOrgId(String orgId) {
        this.orgId = orgId;
    }
    @Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(1)",nullable=true,renewable=false)
    public String getArticleType() {
        return articleType;
    }
    public void setArticleType(String articleType) {
        this.articleType = articleType;
    }
    @Column(handlerClass=IntHandler.class,dbType="INTEGER",renewable=false)
    public int getArticleAgree() {
        return articleAgree;
    }
    public void setArticleAgree(int articleAgree) {
        this.articleAgree = articleAgree;
    }
    @Column(handlerClass=IntHandler.class,dbType="INTEGER",nullable=true,renewable=false)
    public int getPageViews() {
        return pageViews;
    }
    public void setPageViews(int pageViews) {
        this.pageViews = pageViews;
    }
    @Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(1)",nullable=true,renewable=false)
    public String getStatus() {
        return status;
    }
    public void setStatus(String status) {
        this.status = status;
    }
    @Column(DE.bigSerial)
    public long getShareId() {
        return shareId;
    }
    public void setShareId(long shareId) {
        this.shareId = shareId;
    }

    @Column(handlerClass=LongHandler.class,dbType="BIGINT",fixSqlValueWithInsert="0",insertable=true,renewable=false,nullable=false,queryable=true)
    public long getSortNum() {
        return sortNum;
    }

    public void setSortNum(long sortNum) {
        this.sortNum = sortNum;
    }
}

