package com.ekexiu.console.system.service;

import com.ekexiu.console.system.dao.ArticleDao;
import com.ekexiu.console.system.po.Article;
import com.ekexiu.console.system.pojo.ArticleInfo;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2017/8/3.
 */
@Path("/article")
public class ArticleService {
    @Autowrie
    private ArticleDao articleDao;

    public ArticleDao getArticleDao() {
        return articleDao;
    }

    public void setArticleDao(ArticleDao articleDao) {
        this.articleDao = articleDao;
    }

    @Path("/pq")
    @Get
    public PageQueryResult<ArticleInfo> pageQueryResult(@JdbcConn Connection con, @Nullable String title, @Nullable String name, int orderBy, @Nullable String bt, @Nullable String et, @DefaultValue("1") int pageNo, @DefaultValue("10") int pageSize)throws SQLException {
        if (orderBy == 1) {
            return this.articleDao.queryByTime(con, title == null ? null : "%" + title + "%",  name == null ? "%" : "%" + name + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
        }
        if (orderBy == 2) {
            return this.articleDao.queryByPV(con, title == null ? null : "%" + title + "%",  name == null ? "%" : "%" + name + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
        }
        return null;
    }

    @Post
    @Path("/deleteArticle")
    public void deleteArticle(@JdbcConn(true) Connection con,String[] articleIds) throws SQLException{
        //修改文章状态为删除
        this.articleDao.updateStatus(con, articleIds, "3");
    }

    @Post
    @Path("/sortNum")
    public void updateSortNum(@JdbcConn(true) Connection con,String articleId,long sortNum) throws SQLException{
        this.articleDao.updateSortNum(con, articleId, sortNum);
    }

    @Get
    @Path("/id/{id}")
    public Article query(@JdbcConn Connection con, @PathVar String id) throws SQLException {
        return this.articleDao.query(con, id);
    }
}
