package com.ekexiu.console.system.service;

import com.ekexiu.console.system.dao.OrgKeyWordDao;
import com.ekexiu.console.system.dao.ProKeyWordDao;
import com.ekexiu.console.system.po.OrgKeyWord;
import com.ekexiu.console.system.po.ProKeyWord;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Bean;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.Collections;
import java.util.HashSet;

/**
 * Created by TT on 2017/8/10.
 */
@Bean
public class KeyWordService {

    @Autowrie
    private ProKeyWordDao proKeyWordDao;
    @Autowrie
    private OrgKeyWordDao orgKeyWordDao;

    public ProKeyWordDao getProKeyWordDao() {
        return proKeyWordDao;
    }

    public void setProKeyWordDao(ProKeyWordDao proKeyWordDao) {
        this.proKeyWordDao = proKeyWordDao;
    }

    public OrgKeyWordDao getOrgKeyWordDao() {
        return orgKeyWordDao;
    }

    public void setOrgKeyWordDao(OrgKeyWordDao orgKeyWordDao) {
        this.orgKeyWordDao = orgKeyWordDao;
    }

    public void refreshProfessor(Connection con, String id, String[] kws) throws SQLException {
        proKeyWordDao.delete(con, id);
        if (kws != null && kws.length > 0) {
            ProKeyWord[] okws = new ProKeyWord[kws.length];
            for (int i = 0; i < kws.length; ++i) {
                ProKeyWord okw = new ProKeyWord();
                okw.setId(id);
                okw.setKw(kws[i]);
                okws[i] = okw;
            }
            proKeyWordDao.insert(con, okws);
        }
    }

    public void refreshOrg(Connection con, String id, String[] kws) throws SQLException {
        orgKeyWordDao.delete(con, id);
        if (kws != null && kws.length > 0) {
            OrgKeyWord[] okws = new OrgKeyWord[kws.length];
            for (int i = 0; i < kws.length; ++i) {
                OrgKeyWord okw = new OrgKeyWord();
                okw.setId(id);
                okw.setKw(kws[i]);
                okws[i] = okw;
            }
            orgKeyWordDao.insert(con, okws);
        }
    }

    public static String[] splitKeyWord(String kws) {
        if (kws == null || kws.trim().length() == 0) return null;
        kws = kws.trim();
        String[] s = kws.split(",");
        HashSet<String> result = new HashSet<String>();
        Collections.addAll(result, s);
        result.remove("");

        return result.isEmpty() ? null : result.toArray(new String[result.size()]);

    }

    public static void main(String[] args) {
        String s = ",asd,asd,dsa,dsa,we,we,xmtt,ttmx ,ttmx,";
        String[] s1 = splitKeyWord(s);
        for (String aS1 : s1) {
            System.out.println(aS1);
        }
    }

}