package com.ekexiu.console.system.service;

import com.ekexiu.console.system.dao.PpatentDao;
import com.ekexiu.console.system.po.Ppatent;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2017/8/9.
 */
@Path("/patent")
public class PatentService {

    @Autowrie
    private PpatentDao ppatentDao;

    public PpatentDao getPpatentDao() {
        return ppatentDao;
    }

    public void setPpatentDao(PpatentDao ppatentDao) {
        this.ppatentDao = ppatentDao;
    }

    @Path("/pq")
    @Get
    public PageQueryResult<Ppatent> pageQueryResult(@JdbcConn Connection con, @Nullable String title, @Nullable String name, int orderBy, @Nullable String bt, @Nullable String et, @DefaultValue("1") int pageNo, @DefaultValue("10") int pageSize)throws SQLException {
        if (orderBy == 1) {
            return this.ppatentDao.queryByTime(con, title == null ? null : "%" + title + "%",  name == null ? "%" : "%" + name + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
        }
        if (orderBy == 2) {
            return this.ppatentDao.queryByPV(con, title == null ? null : "%" + title + "%",  name == null ? "%" : "%" + name + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
        }
        return null;
    }

    @Post
    @Path("/sortNum")
    public void updateSortNum(@JdbcConn(true) Connection con,String id,long sortNum) throws SQLException{
        this.ppatentDao.updateSortNum(con, id, sortNum);
    }

    @Get
    @Path("/id/{id}")
    public Ppatent query(@JdbcConn Connection con, @PathVar String id) throws SQLException {
        return this.ppatentDao.query(con, id);
    }
}
